// TemplateBlockDlg.cpp : implementation of CTemplateBlock properties dialog.
//

#include "stdafx.h"

#include "resource.h"
#include "TemplateBlockDlg.h"
#include "Engine/Engine.h"
#include "SDI/SDIInterface.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


/////////////////////////////////////////////////////////////////////////////
// CTemplateBlockDlg dialog
// 
CTemplateBlockDlg::CTemplateBlockDlg(CWnd* pParent /*=NULL*/)
	: TDialog(CTemplateBlockDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CTemplateBlockDlg)
	m_iAIOChannel = -1;
	m_iAIOModule = -1;
	m_iDIOChannel = -1;
	m_iDIOModule = -1;
	//}}AFX_DATA_INIT

   m_iSDIAddressIdx = -1;
}


void CTemplateBlockDlg::DoDataExchange(CDataExchange* pDX)
{
	TDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CTemplateBlockDlg)
	DDX_Control(pDX, IDC_SDI_ADDRESS, m_cbSDIAddress);
	DDX_CBIndexOneBased(pDX, IDC_AIO_CHANNEL, m_iAIOChannel);
	DDX_CBIndexOneBased(pDX, IDC_AIO_MODULE, m_iAIOModule);
	DDX_CBIndexOneBased(pDX, IDC_DIO_CHANNEL, m_iDIOChannel);
	DDX_CBIndexOneBased(pDX, IDC_DIO_MODULE, m_iDIOModule);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CTemplateBlockDlg, TDialog)
	//{{AFX_MSG_MAP(CTemplateBlockDlg)
	ON_CBN_SELENDOK(IDC_AIO_MODULE, OnSelendokAioModule)
	ON_CBN_SELENDOK(IDC_DIO_MODULE, OnSelendokDioModule)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CTemplateBlockDlg message handlers

BOOL CTemplateBlockDlg::OnInitDialog() 
{
   m_iOldAIOModule = m_iAIOModule;
   Engine.IOModList.SetModuleList(*this, IDC_AIO_MODULE);
   Engine.IOModList.SetAnalogInputList(*this, IDC_AIO_CHANNEL, m_iAIOModule, 
         m_iOldAIOModule, m_iAIOChannel);
   m_iOldAIOChannel = m_iAIOChannel;

   m_iOldDIOModule = m_iDIOModule;
   Engine.IOModList.SetModuleList(*this, IDC_DIO_MODULE);
   Engine.IOModList.SetDigitalInputList(*this, IDC_DIO_CHANNEL, m_iDIOModule, 
         m_iOldDIOModule, m_iDIOChannel);
   m_iOldDIOChannel = m_iDIOChannel;

   TDialog::OnInitDialog();

   // Initialize the SDI Address combo box list.
   for (int i = 0; i < (int)_tcsclen(szSDIAddrSet); i++)
      m_cbSDIAddress.AddString((CString)szSDIAddrSet[i]);
   m_cbSDIAddress.SetCurSel(m_iSDIAddressIdx);

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}


void CTemplateBlockDlg::OnSelendokAioModule() 
{
   UpdateData(TRUE);
   Engine.IOModList.SetAnalogInputList(*this, IDC_AIO_CHANNEL, m_iAIOModule, 
         m_iOldAIOModule, m_iOldAIOChannel);
   UpdateData(FALSE);
}


void CTemplateBlockDlg::OnSelendokDioModule() 
{
   UpdateData(TRUE);
   Engine.IOModList.SetDigitalInputList(*this, IDC_DIO_CHANNEL, m_iDIOModule, 
         m_iOldDIOModule, m_iOldDIOChannel);
   UpdateData(FALSE);
}


void CTemplateBlockDlg::OnOK() 
{
   m_iSDIAddressIdx = m_cbSDIAddress.GetCurSel();

   TDialog::OnOK();
}


